.macro Execute_SPC SaveCycles=1
    pusha
.if \SaveCycles-0
    cmpb $0,CPU_Executing
    movl %ebp,%eax
    jnz 9f
    movl SNES_Cycles,%eax
9:  // Update CPU and SPC cycles
    movl SPC_last_cycles,%edi
    movl %eax,SPC_last_cycles
    subl %edi,%eax
    addl SPC_CPU_cycles,%eax
.endif

    movl %eax,%ecx          // We don't want to lose cycles..
    andl $(~31),%eax
    andl $31,%ecx
    shrl $5,%eax            // Divide by 32
    movl %ecx,SPC_CPU_cycles
    leal (%eax,%eax,2),%eax // Multiply by 3
    addl %eax,SPC_Cycles    // Add new balance of SPC cycles
    jle 9f
    call SPC_START
9:  popa
.endm
